Create or replace an External MCP Connection by stable key
curl --request PUT \
--url http://api.den.local/v1/mcp-connections/by-key/{externalKey} \
--header 'Content-Type: application/json' \
--data '
{
"name": "<string>",
"url": "<string>",
"kind": "external_mcp",
"credentialMode": "shared",
"exposeDirectly": false,
"apiKey": "<string>",
"authorizationServerIssuer": "<string>",
"requestedScopes": [
"<string>"
],
"access": {
"orgWide": false,
"memberIds": [],
"teamIds": []
}
}
'import requests
url = "http://api.den.local/v1/mcp-connections/by-key/{externalKey}"
payload = {
"name": "<string>",
"url": "<string>",
"kind": "external_mcp",
"credentialMode": "shared",
"exposeDirectly": False,
"apiKey": "<string>",
"authorizationServerIssuer": "<string>",
"requestedScopes": ["<string>"],
"access": {
"orgWide": False,
"memberIds": [],
"teamIds": []
}
}
headers = {"Content-Type": "application/json"}
response = requests.put(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PUT',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
name: '<string>',
url: '<string>',
kind: 'external_mcp',
credentialMode: 'shared',
exposeDirectly: false,
apiKey: '<string>',
authorizationServerIssuer: '<string>',
requestedScopes: ['<string>'],
access: {orgWide: false, memberIds: [], teamIds: []}
})
};
fetch('http://api.den.local/v1/mcp-connections/by-key/{externalKey}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"id": "<string>",
"name": "<string>",
"externalKey": "<string>",
"url": "<string>",
"authType": "oauth",
"credentialMode": "shared",
"exposeDirectly": true,
"connected": true,
"connectedAt": "<string>",
"updatedAt": "2023-11-07T05:31:56Z",
"connectedForMe": true,
"requiredBy": [
{
"pluginId": "<string>",
"name": "<string>"
}
],
"identityManagedBy": [
{
"pluginId": "<string>",
"name": "<string>"
}
],
"access": {
"orgWide": true,
"memberIds": [
"<string>"
],
"teamIds": [
"<string>"
]
},
"identityChanged": true,
"reconnectionRequired": true,
"createdByName": "<string>",
"needsReconnect": true,
"credentialHealth": "unknown",
"credentialHealthReason": "authorization_rejected",
"credentialHealthCheckedAt": "2023-11-07T05:31:56Z",
"issuerReviewRequired": true,
"reconnectActionOwner": "member",
"missingFeatures": [
"<string>"
],
"externalAccountId": "<string>",
"grantedScopes": [
"<string>"
],
"tenantId": "<string>",
"requiredAuthType": "oauth",
"authPolicyConfirmed": true,
"authTypeMismatch": true,
"oauthClientConfigured": true,
"oauthClientRequired": true,
"setupRequired": true,
"oauthClientId": "<string>",
"oauthCallbackUrl": "<string>",
"oauthSharedCallbackUrl": "<string>",
"oauthClientMetadataUrl": "<string>",
"oauthCallbackMode": "shared-v1",
"oauthRegistrationSource": "pre-registered",
"authorizationServerIssuer": "<string>",
"requestedScopes": [
"<string>"
]
}{
"id": "<string>",
"name": "<string>",
"externalKey": "<string>",
"url": "<string>",
"authType": "oauth",
"credentialMode": "shared",
"exposeDirectly": true,
"connected": true,
"connectedAt": "<string>",
"connectedForMe": true,
"requiredBy": [
{
"pluginId": "<string>",
"name": "<string>"
}
],
"access": {
"orgWide": true,
"memberIds": [
"<string>"
],
"teamIds": [
"<string>"
]
},
"links": {
"yourConnections": "<string>",
"oauthCallback": "<string>"
},
"createdByName": "<string>",
"updatedAt": "2023-11-07T05:31:56Z",
"needsReconnect": true,
"credentialHealth": "unknown",
"credentialHealthReason": "authorization_rejected",
"credentialHealthCheckedAt": "2023-11-07T05:31:56Z",
"issuerReviewRequired": true,
"reconnectActionOwner": "member",
"missingFeatures": [
"<string>"
],
"externalAccountId": "<string>",
"grantedScopes": [
"<string>"
],
"tenantId": "<string>",
"identityManagedBy": [
{
"pluginId": "<string>",
"name": "<string>"
}
],
"requiredAuthType": "oauth",
"authPolicyConfirmed": true,
"authTypeMismatch": true,
"oauthClientConfigured": true,
"oauthClientRequired": true,
"setupRequired": true,
"oauthClientId": "<string>",
"oauthCallbackUrl": "<string>",
"oauthSharedCallbackUrl": "<string>",
"oauthClientMetadataUrl": "<string>",
"oauthCallbackMode": "shared-v1",
"oauthRegistrationSource": "pre-registered",
"authorizationServerIssuer": "<string>",
"requestedScopes": [
"<string>"
]
}{
"error": "invalid_request",
"details": [
{
"message": "<string>",
"path": [
"<string>"
]
}
],
"capability": "<string>"
}{
"error": "unauthorized"
}{
"error": "forbidden",
"reason": "<string>",
"message": "<string>"
}{
"error": "connection_conflict",
"message": "<string>"
}{
"error": "connection_validation_failed",
"message": "<string>",
"diagnostic": {
"referenceId": "<string>",
"phase": "CONFIGURATION",
"category": "<string>",
"code": "<string>",
"highestPassed": "configured",
"retryable": true,
"actionOwner": "openwork",
"operatorAction": "<string>",
"message": "<string>",
"httpStatus": 349,
"operationPhase": "CONFIGURATION",
"outbound": {
"origin": "<string>",
"pathHash": "<string>"
},
"providerRequestId": "<string>",
"providerStatus": 0,
"providerCode": "<string>",
"payloadBytes": 0,
"jsonRpcCode": 0,
"connectUrl": "<string>"
}
}Capability Sources
Create or replace an External MCP Connection by stable key
Admin-only declarative upsert. Creates a connection when the organization has not used the key, otherwise replaces the keyed connection without changing its stable identity.
PUT
/
v1
/
mcp-connections
/
by-key
/
{externalKey}
Create or replace an External MCP Connection by stable key
Headers
Existing connection updatedAt timestamp required by the caller for conditional replacement.
Path Parameters
Client-chosen stable identifier, unique per organization. Immutable.
Pattern:
^[a-z0-9][a-z0-9._-]{0,127}$Body
application/json
Required string length:
1 - 255Maximum string length:
2048Available options:
oauth, apikey, none Allowed value:
"external_mcp"Available options:
shared, per_member Required string length:
1 - 4096Show child attributes
Show child attributes
Maximum string length:
2048Maximum array length:
100Required string length:
1 - 255Show child attributes
Show child attributes
Response
Connection updated.
Available options:
oauth, apikey, none Available options:
shared, per_member Pattern:
^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Available options:
unknown, ready, reconnect_required Available options:
authorization_rejected, credential_expired, post_authorization_validation_failed Pattern:
^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$Available options:
member, organization_admin Available options:
oauth, apikey, none Available options:
shared-v1, isolated-v1, legacy-v1 Available options:
pre-registered, client-metadata, dynamic Was this page helpful?